#!/usr/bin/env python3
import sys

oldexcepthook = sys.excepthook
def newexcepthook(type,value,traceback):
	oldexcepthook(type,value,traceback)
	#input("Press ENTER to quit.")
sys.excepthook = newexcepthook

import os
p = os.path.join
pUp = os.path.dirname
s = False
if getattr(sys, 'frozen', False) and hasattr(sys, '_MEIPASS'):
	s = os.path.realpath(sys.executable)
else:
	s = os.path.realpath(__file__)
sp = pUp(s)

# script start
import socket
import threading
import queue
bufferSize = 1000

def eprint(*args, **kwargs): print(*args, file=sys.stderr, **kwargs)

connection = False
connectionLock = threading.Lock()

class pipeThread(threading.Thread):
	def __init__(self):
		threading.Thread.__init__(self)
	
	def run(self):
		global connection
		while True:
			data = sys.stdin.buffer.read(bufferSize)
			
			with connectionLock:
				try:
					if type(connection) != bool:
						connection.send(data)
				except Exception as e:
					connection = False
					print(e)

def stringToAddressTuple(addr):
	rtn = addr.rsplit(":",1)
	rtn[1] = int(rtn[1])
	rtn = tuple(rtn)
	return rtn

def addressTupleToString(addr):
	return ":".join(map(str,list(addr)))

serverAddr = stringToAddressTuple(sys.argv[1])
serverSocket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
eprint("Opening socket...")
serverSocket.bind(serverAddr)
eprint("Serving on " +addressTupleToString(serverAddr)+ "!")
serverSocket.listen(1)

pThread = pipeThread()
pThread.start()

while True:
	eprint("Awaiting connection...")
	conn, address = serverSocket.accept()
	eprint("Connection established, sending data.")
	with connectionLock:
		try:
			if type(connection) != bool:
				connection.close()
		except Exception as e:
			print(e)
		
		connection = conn
		connection.settimeout(15)